import type { _NSCopying } from "../Foundation/NSCopying.js";
import type { _NSObject } from "../Foundation/NSObject.js";
import type { _NSSecureCoding } from "../Foundation/NSSecureCoding.js";
import type { _NSString } from "../Foundation/NSString.js";
import type { _WKPreferences } from "./WKPreferences.js";
import type { _WKProcessPool } from "./WKProcessPool.js";
import type { _WKURLSchemeHandler } from "./WKURLSchemeHandler.js";
import type { _WKUserContentController } from "./WKUserContentController.js";
import type { _WKWebExtensionController } from "./WKWebExtensionController.js";
import type { _WKWebpagePreferences } from "./WKWebpagePreferences.js";
import type { _WKWebsiteDataStore } from "./WKWebsiteDataStore.js";
import type { WKAudiovisualMediaTypes } from "./WKAudiovisualMediaTypes.js";
import type { WKUserInterfaceDirectionPolicy } from "./WKUserInterfaceDirectionPolicy.js";
import type { NSWritingToolsBehavior } from "../AppKit/NSWritingToolsBehavior.js";
export declare class _WKWebViewConfiguration extends _NSObject {
    static alloc(): _WKWebViewConfiguration;
    static new(): _WKWebViewConfiguration;
    init(): _WKWebViewConfiguration;
    /**
     * Sets the URL scheme handler object for the given URL scheme. The object to register. The URL scheme the object will handle. Each URL scheme can only have one URL scheme handler object registered. An exception will be thrown if you try to register an object for a particular URL scheme more than once. URL schemes are case insensitive. e.g. "myprotocol" and "MyProtocol" are equivalent. Valid URL schemes must start with an ASCII letter and can only contain ASCII letters, numbers, the '+' character, the '-' character, and the '.' character. An exception will be thrown if you try to register a URL scheme handler for an invalid URL scheme. An exception will be thrown if you try to register a URL scheme handler for a URL scheme that WebKit handles internally. You can use +[WKWebView handlesURLScheme:] to check the availability of a given URL scheme.
     */
    setURLSchemeHandler$forURLScheme$(urlSchemeHandler: _WKURLSchemeHandler | null, urlScheme: _NSString): void;
    /**
     * Returns the currently registered URL scheme handler object for the given URL scheme. The URL scheme to lookup.
     */
    urlSchemeHandlerForURLScheme$(urlScheme: _NSString): _WKURLSchemeHandler | null;
    /**
     * The process pool from which to obtain the view's web content process. When a web view is initialized, a new web content process will be created for it from the specified pool, or an existing process in that pool will be used.
     * @deprecated Creating and using multiple instances of WKProcessPool no longer has any effect.
     */
    processPool(): _WKProcessPool;
    setProcessPool$(value: _WKProcessPool): void;
    /** The preference settings to be used by the web view. */
    preferences(): _WKPreferences;
    setPreferences$(value: _WKPreferences): void;
    /** The user content controller to associate with the web view. */
    userContentController(): _WKUserContentController;
    setUserContentController$(value: _WKUserContentController): void;
    /** The web extension controller to associate with the web view. */
    webExtensionController(): _WKWebExtensionController | null;
    setWebExtensionController$(value: _WKWebExtensionController | null): void;
    /** The website data store to be used by the web view. */
    websiteDataStore(): _WKWebsiteDataStore;
    setWebsiteDataStore$(value: _WKWebsiteDataStore): void;
    /**
     * A Boolean value indicating whether the web view suppresses content rendering until it is fully loaded into memory. The default value is NO.
     */
    suppressesIncrementalRendering(): boolean;
    setSuppressesIncrementalRendering$(value: boolean): void;
    /** The name of the application as used in the user agent string. */
    applicationNameForUserAgent(): _NSString | null;
    setApplicationNameForUserAgent$(value: _NSString | null): void;
    /**
     * A Boolean value indicating whether AirPlay is allowed. The default value is YES.
     */
    allowsAirPlayForMediaPlayback(): boolean;
    setAllowsAirPlayForMediaPlayback$(value: boolean): void;
    /**
     * A Boolean value indicating whether the System Screen Time blocking view should be shown. The default value is YES.
     */
    showsSystemScreenTimeBlockingView(): boolean;
    setShowsSystemScreenTimeBlockingView$(value: boolean): void;
    /**
     * A Boolean value indicating whether HTTP requests to servers known to support HTTPS should be automatically upgraded to HTTPS requests. The default value is YES.
     */
    upgradeKnownHostsToHTTPS(): boolean;
    setUpgradeKnownHostsToHTTPS$(value: boolean): void;
    mediaTypesRequiringUserActionForPlayback(): WKAudiovisualMediaTypes;
    setMediaTypesRequiringUserActionForPlayback$(value: WKAudiovisualMediaTypes): void;
    /**
     * The set of default webpage preferences to use when loading and rendering content. These default webpage preferences are additionally passed to the navigation delegate in -webView:decidePolicyForNavigationAction:preferences:decisionHandler:.
     */
    defaultWebpagePreferences(): _WKWebpagePreferences;
    setDefaultWebpagePreferences$(value: _WKWebpagePreferences): void;
    limitsNavigationsToAppBoundDomains(): boolean;
    setLimitsNavigationsToAppBoundDomains$(value: boolean): void;
    /**
     * A Boolean value indicating whether inline predictions are allowed. The default value is `NO`. If false, inline predictions are disabled regardless of the system setting. If true, they are enabled based on the system setting.
     */
    allowsInlinePredictions(): boolean;
    setAllowsInlinePredictions$(value: boolean): void;
    /**
     * The directionality of user interface elements. Possible values are described in WKUserInterfaceDirectionPolicy. The default value is WKUserInterfaceDirectionPolicyContent.
     */
    userInterfaceDirectionPolicy(): WKUserInterfaceDirectionPolicy;
    setUserInterfaceDirectionPolicy$(value: WKUserInterfaceDirectionPolicy): void;
    /**
     * A Boolean value indicating whether insertion of adaptive image glyphs is allowed. The default value is `NO`. If `NO`, adaptive image glyphs are inserted as regular images. If `YES`, they are inserted with the full adaptive sizing behavior.
     */
    supportsAdaptiveImageGlyph(): boolean;
    setSupportsAdaptiveImageGlyph$(value: boolean): void;
    /**
     * The preferred behavior of Writing Tools. The default behavior is equivalent to `NSWritingToolsBehaviorLimited`.
     */
    writingToolsBehavior(): NSWritingToolsBehavior;
    setWritingToolsBehavior$(value: NSWritingToolsBehavior): void;
}
export interface _WKWebViewConfiguration extends _NSSecureCoding, _NSCopying {
}
